Index: codes/icosagcm/trunk/param_sets/shallow_water/williamson91/test6/earth_const.def
===================================================================
--- codes/icosagcm/trunk/param_sets/shallow_water/williamson91/test6/earth_const.def	(revision 168)
+++ codes/icosagcm/trunk/param_sets/shallow_water/williamson91/test6/earth_const.def	(revision 168)
@@ -0,0 +1,23 @@
+#planetary radius : real (default=37122E6)
+radius=6.37122E6
+
+# gravity : real (default=9.80616)
+g=9.80616
+
+#planetary rotation rate (default=7.292E-5)
+omega=7.292E-5
+
+# kappa=Rd/cpp (default=0.2857143)
+kappa=0.2857143
+  
+# Heat capacity at constant pressure real (default=1004.70885)
+cpp=1004.5
+
+# Reference pressure : real (default=101325.)
+preff=100000.
+
+# Scale factor for small planet experiment : real (default=1.)
+scale_factor=1.
+
+# Precision of NetCDF output
+netcdf_prec = float
Index: codes/icosagcm/trunk/param_sets/shallow_water/williamson91/test6/run.def
===================================================================
--- codes/icosagcm/trunk/param_sets/shallow_water/williamson91/test6/run.def	(revision 168)
+++ codes/icosagcm/trunk/param_sets/shallow_water/williamson91/test6/run.def	(revision 168)
@@ -0,0 +1,141 @@
+INCLUDEDEF=earth_const.def
+
+# ------------------------------- Mesh ---------------------------------
+
+# Number of subdivision on a main triangle (nbp) : integer (default=40)
+nbp=160
+#nbp=40
+
+# Schmidt tranform (default=1.,0,90.)
+#schmidt_factor=4.
+#schmidt_lon=180.
+#schmidt_lat=50.
+
+# nbp                 20  40  80 160
+# T-edge length (km) 500 250 120  60
+
+# sub splitting of main rhombus : integer (default=1)
+nsplit_i=2
+nsplit_j=3
+
+# Number of vertical layer (llm) : integer (default=19)
+llm=1
+
+# Vertical coordinate : eta_mass (mass-based hybrid, default) or eta_lag (Lagrangian)
+caldyn_eta=eta_lag
+boussinesq=.TRUE.
+
+# disvert : vertical discretisation : string (default='std') : std, ncar, ncar30l
+disvert=none
+
+# optim_it : mesh optimisation : number of iteration : integer (default=0)
+#optim_it=1000
+optim_it=100
+
+# ---------------------------------- Time---------------------------------
+
+# scheme type : string ( default='runge_kutta') euler, leapfrog_matsuno, runge_kutta )
+scheme = runge_kutta
+
+# matsuno period : integer ( default=5)
+matsuno_period = 5
+
+# timestep : real (default=480s)
+dt = 120
+
+# advection called every itau_adv time steps : integer (default 2)
+# standard : umax=100m/s vs c=340m/s (ratio 1:3)
+# in JW06 umax=35m/s vs c=340m/s (ratio 1:10)
+itau_adv=30
+
+# number of timestep (default 100)
+# itaumax = 10000
+
+# run length : real (default=dt*itaumax)
+run_length=2592000
+#run_length=864000
+#run_length=86400
+#run_length=7200
+
+# output field period : integer (default none)
+#write_period=7200
+write_period=86400
+#write_period=480
+
+# ---------------------------------- Misc --------------------------------
+
+# number of tracer (nqtot) : integer (default 1)
+nqtot=1
+
+# pression value where output is interpolated : real (default=0, no output)
+out_pression_level=85000
+
+# etat0 : initial state : string (default=jablonowsky06) : 
+# jablonowsky06, academic, ncar
+etat0=williamson91.6
+
+# ------------------------------ Dynamics --------------------------------
+
+# caldyn : computation type for gcm equation : string (default=gcm) : gcm, adv
+caldyn=gcm
+
+# caldyn_conserv : string (default=energy) : energy,enstrophy
+caldyn_conserv=energy
+
+# guided_type : string (default=none) : none, ncar
+guided_type=none
+
+# ---------------------------------- Dissipation ---------------------------------
+
+# dissipation time graddiv : real (default=5000)
+tau_graddiv = 5000
+
+# number of iteration for graddiv : integer (default=1)
+nitergdiv = 2
+
+# dissipation time nxgradrot (default=5000)
+tau_gradrot = 500
+
+# number of iteration for nxgradrot : integer (default=1)
+nitergrot=2
+
+# dissipation time divgrad (theta) (default=5000)
+tau_divgrad=5000
+
+# number of iteration for divgrad : integer (default=1)
+niterdivgrad=2
+
+# Rayleigh friction : string (default=none) : none, dcmip2_schaer_noshear, dcmip2_schaer_shear
+rayleigh_friction_type=none
+
+# -------------------------------- Physics -------------------------------------
+
+# kind of physics : string : none, dcmip (default=none)
+physics=none
+
+# -------------------- parameters for NCAR test cases ------------------------
+
+# NCAR advection test, initial tracer : string ( default='cos_bell')
+# const, slotted_cyl, cos_bell, dbl_cos_bell_q1, dbl_cos_bell_q2, complement, hadley
+ncar_adv_shape=cos_bell
+
+# NCAR advection test, wind field : string (default='deform') : solid, deform, hadley
+ncar_adv_wind=solid
+
+# ncar_T0 : reference temperature for NCAR test cases : real (default=300) 
+# also used by disvert if disvert=ncar
+ncar_T0=300
+
+# ncar_p0 : reference pressure for NCAR test cases : real (default=1e5) 
+# also used by disvert if disvert=ncar
+ncar_p0=1e5
+
+# ncar_disvert_c : exponent for B(eta) : integer (default=1)
+# used by disvert if disvert=ncar
+
+ncar_disvert_c=1
+
+# dcmip 4 testcase : integer (default=1) : 1, 2
+dcmip4_testcase=1
+
+#-----------------------------------------------------------------------
Index: codes/icosagcm/trunk/src/etat0.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0.f90	(revision 167)
+++ codes/icosagcm/trunk/src/etat0.f90	(revision 168)
@@ -42,5 +42,5 @@
     
     SELECT CASE (TRIM(etat0_type))
-    CASE ('williamson91.5')
+    CASE ('williamson91.6')
        CALL etat0_williamson_new(f_phis,f_mass,f_theta_rhodz,f_u, f_q)
        init_mass=.FALSE.